import com.browsersoft.fhir.objects.FhirObject;
import com.browsersoft.fhir.objects.wrapped.FhirEncounter;
import com.browsersoft.fhir.objects.wrapped.FhirIdentifier;
import com.browsersoft.fhir.settings.Fhir2Templates;
import com.browsersoft.partners.fhir2partner.DownloadResourcesContext;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class downloadResources {

    public List<String> getCallTypes( Fhir2Templates templates ) throws Exception {
        List<String> ret = new ArrayList<>();
        ret.add("AllergyIntolerance");
        ret.add("AssessPlan");
        ret.add("CareTeam");
        ret.add("Device");
        ret.add("Condition");
        ret.add("DocumentReference");
        ret.add("Encounter");
        ret.add("Goal");
        ret.add("Immunization");
        ret.add("MedicationRequest");
        ret.add("SocialHistory");
        ret.add("VitalSigns");
        ret.add("Laboratory");
        ret.add("Therapy");
        ret.add("Procedure");
        return ret;
    }

    public void downloadResources( DownloadResourcesContext context ) throws Exception {

        Map<String, Object> paramsProv = new HashMap<>();
        paramsProv.put("patient", context.getPatientResourceId());
        paramsProv.put("_revinclude", "Provenance:target");

        Map<String, Object> paramsid = new HashMap<>();
        paramsid.put("patient", context.getPatientResourceId());

        //context.downloadResources("/Encounter", 10, paramsProv, "Encounter");
        // List<FhirObject> encounters = context.getResult().getObjectsByType("Encounter");

       /* List<FhirObject> selectedEncounters;
        Date startDate = context.getMedicalData().getStartDate();
        Date endDate = context.getMedicalData().getEndDate();

        if ( startDate != null || endDate != null ) {

            selectedEncounters = new ArrayList<>();
            for (FhirObject object : encounters) {
                FhirEncounter encounter = (FhirEncounter) object;
                if (encounter.getPeriod() != null) {
                    Date start = encounter.getPeriod().getStart();
                    Date end = encounter.getPeriod().getEnd();
                    boolean add = true;
                    if ( startDate != null && start != null ) {
                        if ( start.getTime() < startDate.getTime()) {
                            add = false;
                        }
                    }
                    if ( endDate != null && end != null ) {
                        if ( end.getTime() > endDate.getTime()) {
                            add = false;
                        }
                    }
                    if ( add ) {
                        selectedEncounters.add(encounter);
                    }
                }
            }
        } else {
            selectedEncounters = encounters;
        }

        context.getResult().clearObjects();
        context.getResult().addObjects(selectedEncounters);

  */
        context.downloadResourcesAsync("/AllergyIntolerance", 10, paramsid, "AllergyIntolerance");
        // context.downloadResourcesAsync("/Immunization", 10, paramsid, "Immunization");

        List<String> encounters = new ArrayList<>();
        encounters.add("97953477");
        encounters.add("16131");
/*
        for ( String encounter : encounters ) {
            Map<String, Object> encounterId = new HashMap<>();
            paramsid.put("patient", context.getPatientResourceId());
            paramsid.put("encounter", "97953477");
            context.downloadResources("/Encounter/" + encounter., 10, paramsProv, "Encounter");
        }
        */
        for (String encounterId : encounters) {

            Map<String, Object> paramsPerEncounter = new HashMap<>();
            paramsPerEncounter.put("patient", context.getPatientResourceId());
            paramsPerEncounter.put("encounter", encounterId);

            context.downloadResourcesAsync("/Condition", 10, paramsPerEncounter, "Condition");

            context.downloadResourcesAsync("/DocumentReference", 10, paramsPerEncounter, "DocumentReference"); //get concurrent modification errors when passing paramsProv

        }


    }

}